diff --git a/src/backend/access/heap/heapam_indexscan.c b/src/backend/access/heap/heapam_indexscan.c
index 32d6aff1d..323c245cd 100644
--- a/src/backend/access/heap/heapam_indexscan.c
+++ b/src/backend/access/heap/heapam_indexscan.c
@@ -16,6 +16,7 @@
 
 #include "access/amapi.h"
 #include "access/heapam.h"
+#include "access/indexbatch.h"
 #include "access/relscan.h"
 #include "access/visibilitymap.h"
 #include "storage/predicate.h"
@@ -24,6 +25,38 @@
 #include "utils/pgstat_internal.h"
 
 
+/*
+ * heapam's per-batch private opaque area (only used during index-only scans).
+ *
+ * Maintains a per-batch visibility information cache, populated on demand
+ * using the visibility map.  It is important that we set each batch item's
+ * batchvis[] entry exactly once (or not at all).
+ */
+typedef struct HeapBatchData
+{
+	/*
+	 * Range of batchvis[] entries with valid visibility info, in items[]-wise
+	 * terms.  An item's visibility is cached iff firstVisSet <= item <=
+	 * lastVisSet.
+	 */
+	int			firstVisSet;	/* first valid batchvis[] entry, or > last */
+	int			lastVisSet;		/* last valid batchvis[] entry, or < first */
+
+	/* maxitemsbatch-many all-visible states, valid only within range */
+	bool		batchvis[FLEXIBLE_ARRAY_MEMBER];
+} HeapBatchData;
+
+#define HEAP_BATCH_VIS_CACHED(hbatch, item) \
+	((item) >= (hbatch)->firstVisSet && (item) <= (hbatch)->lastVisSet)
+
+static bool heapam_index_plain_batch_getnext_slot(IndexScanDesc scan,
+												  ScanDirection direction,
+												  TupleTableSlot *slot,
+												  bool *recheck);
+static bool heapam_index_only_batch_getnext_slot(IndexScanDesc scan,
+												 ScanDirection direction,
+												 TupleTableSlot *slot,
+												 bool *recheck);
 static bool heapam_index_plain_tuple_getnext_slot(IndexScanDesc scan,
 												  ScanDirection direction,
 												  TupleTableSlot *slot,
@@ -36,11 +69,28 @@ static pg_attribute_always_inline bool heapam_index_getnext_slot(IndexScanDesc s
 																 ScanDirection direction,
 																 TupleTableSlot *slot,
 																 bool index_only,
+																 bool amgetbatch,
 																 bool *recheck);
 static pg_attribute_always_inline bool heapam_index_heap_fetch(IndexScanDesc scan, IndexScanHeapData *hscan,
 															   TupleTableSlot *slot, bool index_only,
 															   bool *heap_continue, bool *all_dead);
-static pg_attribute_always_inline void heapam_index_kill_item(IndexScanDesc scan);
+static pg_attribute_always_inline void heapam_index_kill_item(IndexScanDesc scan,
+															  bool amgetbatch);
+static pg_attribute_always_inline ItemPointer heapam_index_getnext_scanbatch_pos(IndexScanDesc scan,
+																				 IndexScanHeapData *hscan,
+																				 ScanDirection direction,
+																				 bool *all_visible);
+static inline ItemPointer heapam_index_return_scanpos_tid(IndexScanDesc scan,
+														  IndexScanHeapData *hscan,
+														  ScanDirection direction,
+														  IndexScanBatch scanBatch,
+														  BatchRingItemPos *scanPos,
+														  bool *all_visible);
+static void heapam_index_batch_pos_visibility(IndexScanDesc scan,
+											  ScanDirection direction,
+											  IndexScanBatch batch,
+											  HeapBatchData *hbatch,
+											  BatchRingItemPos *pos);
 
 /*
  * Simple, single-shot TID lookup for constraint enforcement code (unique
@@ -90,18 +140,52 @@ heapam_index_scan_begin(IndexScanDesc scan, uint32 flags)
 {
 	IndexScanHeapData *hscan = palloc0_object(IndexScanHeapData);
 
-	hscan->xs_cbuf = InvalidBuffer;
+	/* table AM opaque area size is set below for index-only scans */
+	scan->batch_table_opaque_size = 0;
+
+	/* Current heap block state */
+	Assert(hscan->xs_cbuf == InvalidBuffer);
 	hscan->xs_blk = InvalidBlockNumber;
-	hscan->xs_vmbuffer = InvalidBuffer;
+
+	/* VM related state */
+	Assert(hscan->xs_vmbuffer == InvalidBuffer);
+	hscan->xs_vm_items = 1;
 
 	/* Remember if scan is read-only */
 	hscan->xs_readonly = (flags & SO_HINT_REL_READ_ONLY) != 0;
 
 	/* Resolve which xs_getnext_slot implementation to use for this scan */
-	if (scan->xs_want_itup)
-		scan->xs_getnext_slot = heapam_index_only_tuple_getnext_slot;
+	if (scan->indexRelation->rd_indam->amgetbatch != NULL)
+	{
+		/* amgetbatch index AM */
+		Assert(scan->maxitemsbatch > 0);
+
+		if (scan->xs_want_itup)
+		{
+			scan->xs_getnext_slot = heapam_index_only_batch_getnext_slot;
+
+			/*
+			 * Index-only scans cache visibility info in a HeapBatchData per
+			 * batch: a fixed-size header followed by a per-item batchvis[]
+			 * array (one bool per batch item)
+			 */
+			scan->batch_table_opaque_size = offsetof(HeapBatchData, batchvis) +
+				sizeof(bool) * scan->maxitemsbatch;
+		}
+		else
+			scan->xs_getnext_slot = heapam_index_plain_batch_getnext_slot;
+
+		/* Set up scan's batch ring buffer */
+		tableam_util_batchscan_init(scan);
+	}
 	else
-		scan->xs_getnext_slot = heapam_index_plain_tuple_getnext_slot;
+	{
+		/* amgettuple index AM */
+		if (scan->xs_want_itup)
+			scan->xs_getnext_slot = heapam_index_only_tuple_getnext_slot;
+		else
+			scan->xs_getnext_slot = heapam_index_plain_tuple_getnext_slot;
+	}
 
 	/*
 	 * Index-only scans that return "name" columns stored as cstrings need a
@@ -118,14 +202,44 @@ heapam_index_scan_begin(IndexScanDesc scan, uint32 flags)
 	scan->xs_table_opaque = hscan;
 }
 
+/*
+ * Initialize the heap table AM's per-batch opaque area
+ */
 void
-heapam_index_scan_reset(IndexScanDesc scan)
+heapam_index_scan_batch_init(IndexScanDesc scan, IndexScanBatch batch)
+{
+	HeapBatchData *hbatch;
+
+	/*
+	 * The core code should only call here during index-only scans.  Plain
+	 * scans don't request a HeapBatchData area at all.
+	 */
+	Assert(scan->xs_want_itup && scan->usebatchring);
+
+	/* Resetting the valid range makes it safe to use/recycle the batch */
+	hbatch = index_scan_batch_table_area(scan, batch);
+	hbatch->firstVisSet = INT_MAX;
+	hbatch->lastVisSet = -1;
+}
+
+/*
+ * Reset table AM index scan state in preparation for a rescan
+ */
+void
+heapam_index_scan_rescan(IndexScanDesc scan)
 {
 	IndexScanHeapData *hscan = (IndexScanHeapData *) scan->xs_table_opaque;
 
+	/* Rescans should avoid an excessive number of VM lookups */
+	hscan->xs_vm_items = 1;
+
 	/* Heap fetches from the last rescan don't count towards this limit  */
 	hscan->xs_blkswitch_count = 0;
 
+	/* Reset batch ring buffer state */
+	if (scan->usebatchring)
+		tableam_util_batchscan_reset(scan, false);
+
 	/*
 	 * Deliberately avoid dropping pins now held in xs_cbuf and xs_vmbuffer.
 	 * This saves cycles during certain tight nested loop joins (it can avoid
@@ -150,9 +264,37 @@ heapam_index_scan_end(IndexScanDesc scan)
 	if (hscan->xs_itup_cxt)
 		MemoryContextDelete(hscan->xs_itup_cxt);
 
+	/* Free all batch related resources */
+	if (scan->usebatchring)
+		tableam_util_batchscan_end(scan);
+
 	pfree(hscan);
 }
 
+/*
+ * Save batch ring buffer's current scanPos as its markPos
+ */
+void
+heapam_index_scan_markpos(IndexScanDesc scan)
+{
+	Assert(scan->usebatchring);
+	Assert(scan->indexRelation->rd_indam->amcanmarkpos);
+
+	tableam_util_batchscan_mark_pos(scan);
+}
+
+/*
+ * Restore batch ring buffer's markPos into its scanPos
+ */
+void
+heapam_index_scan_restrpos(IndexScanDesc scan)
+{
+	Assert(scan->usebatchring);
+	Assert(scan->indexRelation->rd_indam->amcanmarkpos);
+
+	tableam_util_batchscan_restore_pos(scan);
+}
+
 /*
  *	heap_hot_search_buffer	- search HOT chain for tuple satisfying snapshot
  *
@@ -400,6 +542,34 @@ heap_fill_ios_slot(IndexScanDesc scan, TupleTableSlot *slot)
 		elog(ERROR, "no data returned for index-only scan");
 }
 
+/* xs_getnext_slot callback: amgetbatch, plain index scan */
+static pg_attribute_hot bool
+heapam_index_plain_batch_getnext_slot(IndexScanDesc scan,
+									  ScanDirection direction,
+									  TupleTableSlot *slot,
+									  bool *recheck)
+{
+	Assert(!scan->xs_want_itup && scan->usebatchring);
+	Assert(scan->indexRelation->rd_indam->amgetbatch != NULL);
+
+	return heapam_index_getnext_slot(scan, direction, slot, false, true,
+									 recheck);
+}
+
+/* xs_getnext_slot callback: amgetbatch, index-only scan */
+static pg_attribute_hot bool
+heapam_index_only_batch_getnext_slot(IndexScanDesc scan,
+									 ScanDirection direction,
+									 TupleTableSlot *slot,
+									 bool *recheck)
+{
+	Assert(scan->xs_want_itup && scan->usebatchring);
+	Assert(scan->indexRelation->rd_indam->amgetbatch != NULL);
+
+	return heapam_index_getnext_slot(scan, direction, slot, true, true,
+									 recheck);
+}
+
 /* xs_getnext_slot callback: amgettuple, plain index scan */
 static pg_attribute_hot bool
 heapam_index_plain_tuple_getnext_slot(IndexScanDesc scan,
@@ -407,10 +577,11 @@ heapam_index_plain_tuple_getnext_slot(IndexScanDesc scan,
 									  TupleTableSlot *slot,
 									  bool *recheck)
 {
-	Assert(!scan->xs_want_itup);
+	Assert(!scan->xs_want_itup && !scan->usebatchring);
 	Assert(scan->indexRelation->rd_indam->amgettuple != NULL);
 
-	return heapam_index_getnext_slot(scan, direction, slot, false, recheck);
+	return heapam_index_getnext_slot(scan, direction, slot, false, false,
+									 recheck);
 }
 
 /* xs_getnext_slot callback: amgettuple, index-only scan */
@@ -420,14 +591,15 @@ heapam_index_only_tuple_getnext_slot(IndexScanDesc scan,
 									 TupleTableSlot *slot,
 									 bool *recheck)
 {
-	Assert(scan->xs_want_itup);
+	Assert(scan->xs_want_itup && !scan->usebatchring);
 	Assert(scan->indexRelation->rd_indam->amgettuple != NULL);
 
-	return heapam_index_getnext_slot(scan, direction, slot, true, recheck);
+	return heapam_index_getnext_slot(scan, direction, slot, true, false,
+									 recheck);
 }
 
 /*
- * Common implementation for both heapam_index_*_getnext_slot variants.
+ * Common implementation for all four heapam_index_*_getnext_slot variants.
  *
  * The result is true if a tuple satisfying the scan keys and the snapshot was
  * found, false otherwise.  On success the slot is filled: for plain index
@@ -439,13 +611,13 @@ heapam_index_only_tuple_getnext_slot(IndexScanDesc scan,
  * dropped by a future call here (or by a later call to heapam_index_scan_end
  * through index_endscan).
  *
- * The index_only parameter is a compile-time constant at each call site,
- * allowing the compiler to specialize the code for each variant.
+ * The index_only and amgetbatch parameters are compile-time constants at each
+ * call site, allowing the compiler to specialize the code for each variant.
  */
 static pg_attribute_always_inline bool
 heapam_index_getnext_slot(IndexScanDesc scan, ScanDirection direction,
 						  TupleTableSlot *slot, bool index_only,
-						  bool *recheck)
+						  bool amgetbatch, bool *recheck)
 {
 	IndexScanHeapData *hscan = (IndexScanHeapData *) scan->xs_table_opaque;
 	bool	   *heap_continue = &scan->xs_heap_continue;
@@ -460,14 +632,22 @@ heapam_index_getnext_slot(IndexScanDesc scan, ScanDirection direction,
 		if (!*heap_continue)
 		{
 			/* Get the next TID from the index */
-			tid = index_getnext_tid(scan, direction);
+			if (amgetbatch)
+				tid = heapam_index_getnext_scanbatch_pos(scan, hscan,
+														 direction,
+														 index_only ?
+														 &all_visible : NULL);
+			else
+				tid = tableam_util_fetch_next_tuple_tid(scan, direction);
 
 			/* If we're out of index entries, we're done */
 			if (tid == NULL)
 				break;
 
-			/* For index-only scans, check the visibility map */
-			if (index_only)
+			pgstat_count_index_tuples(scan->indexRelation, 1);
+
+			/* For non-batch index-only scans, check the visibility map */
+			if (index_only && !amgetbatch)
 				all_visible = VM_ALL_VISIBLE(scan->heapRelation,
 											 ItemPointerGetBlockNumber(tid),
 											 &hscan->xs_vmbuffer);
@@ -493,7 +673,7 @@ heapam_index_getnext_slot(IndexScanDesc scan, ScanDirection direction,
 			{
 				/* No visible tuple */
 				if (all_dead)
-					heapam_index_kill_item(scan);
+					heapam_index_kill_item(scan, amgetbatch);
 
 				/*
 				 * If caller set a visited-pages limit (only selfuncs.c's
@@ -518,8 +698,7 @@ heapam_index_getnext_slot(IndexScanDesc scan, ScanDirection direction,
 			 * us to assume that just having one visible tuple in the hot
 			 * chain is always good enough.
 			 */
-			Assert(!index_only ||
-				   !(*heap_continue && IsMVCCSnapshot(scan->xs_snapshot)));
+			Assert(!index_only || !(*heap_continue && scan->MVCCScan));
 		}
 		else
 		{
@@ -644,7 +823,7 @@ heapam_index_heap_fetch(IndexScanDesc scan, IndexScanHeapData *hscan,
 			 * Only in a non-MVCC snapshot plain scan can more than one member
 			 * of the HOT chain be visible
 			 */
-			*heap_continue = !IsMVCCLikeSnapshot(snapshot);
+			*heap_continue = !scan->MVCCScan;
 
 			slot->tts_tableOid = RelationGetRelid(rel);
 			ExecStoreBufferHeapTuple(heapTuple, slot, hscan->xs_cbuf);
@@ -679,15 +858,303 @@ heapam_index_heap_fetch(IndexScanDesc scan, IndexScanHeapData *hscan,
  * RelationGetIndexScan().
  */
 static pg_attribute_always_inline void
-heapam_index_kill_item(IndexScanDesc scan)
+heapam_index_kill_item(IndexScanDesc scan, bool amgetbatch)
 {
 	if (scan->xactStartedInRecovery)
 		return;
 
-	/*
-	 * Tell amgettuple-based index AM to kill its entry for that TID.  The
-	 * next index_getnext_tid call will pass that along to the index AM,
-	 * before unsetting the flag again.
-	 */
-	scan->kill_prior_tuple = true;
+	if (amgetbatch)
+		tableam_util_scanpos_killitem(scan);
+	else
+	{
+		/*
+		 * Tell amgettuple-based index AM to kill its entry for that TID.  The
+		 * next tableam_util_fetch_next_tuple_tid call will pass that along to
+		 * the index AM, before unsetting the flag again.
+		 */
+		scan->kill_prior_tuple = true;
+	}
+}
+
+/*
+ * Get next TID from batch ring buffer, moving in the given scan direction.
+ * Also sets *all_visible for item when caller passes a non-NULL arg.
+ */
+static pg_attribute_always_inline ItemPointer
+heapam_index_getnext_scanbatch_pos(IndexScanDesc scan, IndexScanHeapData *hscan,
+								   ScanDirection direction, bool *all_visible)
+{
+	BatchRingItemPos *scanPos = &scan->batchringbuf.scanPos;
+	IndexScanBatch scanBatch;
+
+	Assert(all_visible == NULL || scan->xs_want_itup);
+
+	/*
+	 * Attempt to increment the position of any existing loaded scanBatch
+	 * (always fails on first call here for the scan)
+	 */
+	if (tableam_util_scanpos_advance(scan, direction, &scanBatch, scanPos))
+	{
+		/*
+		 * Incremented scanPos within existing loaded scanBatch; return the
+		 * new position's TID to caller
+		 */
+		return heapam_index_return_scanpos_tid(scan, hscan, direction,
+											   scanBatch, scanPos,
+											   all_visible);
+	}
+
+	/* Try to advance scanBatch to the next batch (or get the first batch) */
+	scanBatch = tableam_util_fetch_next_batch(scan, direction,
+											  scanBatch, scanPos);
+
+	if (!scanBatch)
+	{
+		/*
+		 * We're done; no more batches in the current scan direction.
+		 *
+		 * Note: if scanPos was ever valid (if amgetbatch ever returned a
+		 * batch), it remains valid now.  The current scanPos.item is now
+		 * scanBatch.lastItem + 1 (or scanBatch.firstItem - 1, when scanning
+		 * backwards).  We are therefore prepared to move the scan in the
+		 * opposite direction, within our still-loaded scanBatch.  Similarly,
+		 * we can still restore a saved mark in the usual way.
+		 */
+		return NULL;
+	}
+
+	/*
+	 * We have a new scanBatch, but scanPos hasn't been advanced to it just
+	 * yet.  Update batchringbuf and scanPos such that the scan can continue
+	 * with our new scanBatch.
+	 *
+	 * This will position scanPos to the start of our new scanBatch.  It will
+	 * also remove the old head batch/scanBatch from the batch ring buffer,
+	 * and release the underlying batch storage.
+	 */
+	tableam_util_scanpos_nextbatch(scan, direction, scanBatch);
+
+	/*
+	 * Set scanPos to first item for newly loaded scanBatch; return the new
+	 * position's TID to caller
+	 */
+	return heapam_index_return_scanpos_tid(scan, hscan, direction,
+										   scanBatch, scanPos, all_visible);
+}
+
+/*
+ * Save the current scanPos/scanBatch item's TID in scan's xs_heaptid, and
+ * return a pointer to that TID.  When all_visible isn't NULL (during an
+ * index-only scan), also sets item's visibility status in *all_visible.
+ *
+ * heapam_index_getnext_scanbatch_pos helper function.
+ */
+static inline ItemPointer
+heapam_index_return_scanpos_tid(IndexScanDesc scan, IndexScanHeapData *hscan,
+								ScanDirection direction,
+								IndexScanBatch scanBatch,
+								BatchRingItemPos *scanPos,
+								bool *all_visible)
+{
+	HeapBatchData *hbatch;
+
+	/* Set xs_heaptid, which caller (and core executor) will need */
+	scan->xs_heaptid = scanBatch->items[scanPos->item].tableTid;
+
+	if (all_visible == NULL)
+	{
+		/*
+		 * Plain index scan.
+		 */
+		Assert(!scan->xs_want_itup);
+		return &scan->xs_heaptid;
+	}
+
+	/* Index-only scan */
+	Assert(scan->xs_want_itup);
+
+	scan->xs_itup = (IndexTuple) (scanBatch->currTuples +
+								  scanBatch->items[scanPos->item].tupleOffset);
+
+	/*
+	 * Set visibility info for the current scanPos item (plus possibly some
+	 * additional items in the current scan direction) as needed
+	 */
+	hbatch = index_scan_batch_table_area(scan, scanBatch);
+	if (!HEAP_BATCH_VIS_CACHED(hbatch, scanPos->item))
+		heapam_index_batch_pos_visibility(scan, direction,
+										  scanBatch, hbatch, scanPos);
+
+	/* Finally, set all_visible for caller */
+	*all_visible = hbatch->batchvis[scanPos->item];
+
+	return &scan->xs_heaptid;
+}
+
+/*
+ * Obtain visibility information for a TID from caller's batch.
+ *
+ * Called during amgetbatch index-only scans.  We always make sure that the
+ * visibility of caller's item (an offset into caller's batch->items[] array)
+ * has been set in its batch's batchvis[].  We might also set visibility info
+ * for other items from caller's batch more proactively when that makes sense.
+ *
+ * Every item has its batchvis[] entry set exactly once (or never).  We make
+ * sure that the scan has a fixed picture of which blocks it'll need to fetch
+ * in the near future.  If caller's position's item (or other nearby items)
+ * already have a valid batchvis[] entry, we must avoid clobbering that entry.
+ *
+ * We keep two competing considerations in balance when determining whether to
+ * check additional items: the need to keep the cost of visibility map access
+ * under control when most items will never be returned by the scan anyway
+ * (important for inner index scans of anti-joins and semi-joins), and the
+ * need to unguard batches promptly.
+ *
+ * Once we've resolved visibility for all items in a batch, we can safely
+ * unguard it by calling amunguardbatch.  This is safe with respect to
+ * concurrent VACUUM because the batch's guard (typically a buffer pin on the
+ * originating index page) blocks VACUUM from acquiring a conflicting cleanup
+ * lock on that page.  Copying the relevant visibility map data into our local
+ * cache suffices to prevent unsafe concurrent TID recycling: if any of these
+ * TIDs point to dead heap tuples, VACUUM cannot possibly return from
+ * ambulkdelete and mark the pointed-to heap pages as all-visible.  VACUUM
+ * _can_ do so once the batch is unguarded, but that's okay; we'll be working
+ * off of cached visibility info that indicates that the dead TIDs are NOT
+ * all-visible.
+ *
+ * What about the opposite case, where a page was all-visible when we cached
+ * the VM bits but tuples on it are deleted afterwards?  That is safe too: any
+ * tuple that was visible to all when we read the VM must also be visible to
+ * our MVCC snapshot, so it is correct to skip the heap fetch for those TIDs.
+ */
+static void
+heapam_index_batch_pos_visibility(IndexScanDesc scan, ScanDirection direction,
+								  IndexScanBatch batch, HeapBatchData *hbatch,
+								  BatchRingItemPos *pos)
+{
+	IndexScanHeapData *hscan = (IndexScanHeapData *) scan->xs_table_opaque;
+	int			posItem = pos->item;
+	int			loItem,
+				hiItem;
+	BlockNumber curvmheapblkno = InvalidBlockNumber;
+	bool		curvmheapallvis = false;
+
+	Assert(hbatch == index_scan_batch_table_area(scan, batch));
+
+	/*
+	 * The batch must still be guarded whenever we're called.
+	 *
+	 * amunguardbatch can't be called until we've already set _every_ batch
+	 * item's batchvis[] status, but if we've already done so for this batch
+	 * then it shouldn't ever get passed to us again by some subsequent call.
+	 * (This relies on index-only scans always being !batchImmediateUnguard.)
+	 */
+	Assert(batch->isGuarded && !scan->batchImmediateUnguard);
+
+	/*
+	 * Set visibility info for a range of items, in scan order.
+	 *
+	 * Note: visibilitymap_get_status does not lock the visibility map buffer,
+	 * so the result could be slightly stale.  See the "Memory ordering
+	 * effects" discussion above visibilitymap_get_status for an explanation
+	 * of why this is okay.
+	 */
+	if (ScanDirectionIsForward(direction))
+	{
+		int			lastSetItem = Min(batch->lastItem,
+									  posItem + hscan->xs_vm_items - 1);
+
+		for (int setItem = posItem; setItem <= lastSetItem; setItem++)
+		{
+			ItemPointer tid = &batch->items[setItem].tableTid;
+			BlockNumber heapblkno = ItemPointerGetBlockNumber(tid);
+
+			/* Must never overwrite any batch item's cached visibility info */
+			if (HEAP_BATCH_VIS_CACHED(hbatch, setItem))
+				continue;
+
+			if (heapblkno != curvmheapblkno)
+			{
+				curvmheapallvis = VM_ALL_VISIBLE(scan->heapRelation, heapblkno,
+												 &hscan->xs_vmbuffer);
+				curvmheapblkno = heapblkno;
+			}
+
+			hbatch->batchvis[setItem] = curvmheapallvis;
+		}
+
+		/* We just cached visibility for items [posItem, lastSetItem] */
+		loItem = posItem;
+		hiItem = lastSetItem;
+	}
+	else
+	{
+		int			lastSetItem = Max(batch->firstItem,
+									  posItem - hscan->xs_vm_items + 1);
+
+		for (int setItem = posItem; setItem >= lastSetItem; setItem--)
+		{
+			ItemPointer tid = &batch->items[setItem].tableTid;
+			BlockNumber heapblkno = ItemPointerGetBlockNumber(tid);
+
+			/* Must never overwrite any batch item's cached visibility info */
+			if (HEAP_BATCH_VIS_CACHED(hbatch, setItem))
+				continue;
+
+			if (heapblkno != curvmheapblkno)
+			{
+				curvmheapallvis = VM_ALL_VISIBLE(scan->heapRelation, heapblkno,
+												 &hscan->xs_vmbuffer);
+				curvmheapblkno = heapblkno;
+			}
+
+			hbatch->batchvis[setItem] = curvmheapallvis;
+		}
+
+		/* We just cached visibility for items [lastSetItem, posItem] */
+		loItem = lastSetItem;
+		hiItem = posItem;
+	}
+
+	/*
+	 * Extend the batch's valid range to cover the items we just cached.  The
+	 * set of cached items is always contiguous, because the scan visits items
+	 * in order and only ever extends the range from firstItem forwards or
+	 * from lastItem backwards.
+	 */
+	Assert(hbatch->firstVisSet > hbatch->lastVisSet ||	/* still contiguous? */
+		   (loItem <= hbatch->lastVisSet + 1 &&
+			hiItem >= hbatch->firstVisSet - 1));
+	hbatch->firstVisSet = Min(hbatch->firstVisSet, loItem);
+	hbatch->lastVisSet = Max(hbatch->lastVisSet, hiItem);
+
+	/*
+	 * It's safe to unguard the batch (via amunguardbatch) as soon as we've
+	 * resolved the visibility status of all of its items (unless this is a
+	 * non-MVCC scan)
+	 */
+	if (hbatch->firstVisSet <= batch->firstItem &&
+		hbatch->lastVisSet >= batch->lastItem)
+	{
+		Assert(hbatch->firstVisSet == batch->firstItem &&
+			   hbatch->lastVisSet == batch->lastItem);
+
+		/*
+		 * Note: nodeIndexonlyscan.c only supports MVCC snapshots, but we
+		 * still cope with index-only scan callers with other snapshot types.
+		 * This is certainly not unexpected; selfuncs.c performs index-only
+		 * scans that use SnapshotNonVacuumable.
+		 */
+		if (scan->MVCCScan)
+			tableam_util_unguard_batch(scan, batch);
+	}
+
+	/*
+	 * Else check visibility for twice as many items next time, or all items.
+	 * We check all items in one go once we're passed the scan's first batch.
+	 */
+	else if (hscan->xs_vm_items < (batch->lastItem - batch->firstItem))
+		hscan->xs_vm_items *= 2;
+	else
+		hscan->xs_vm_items = scan->maxitemsbatch;
 }
diff --git a/src/backend/access/index/Makefile b/src/backend/access/index/Makefile
index 6f2e3061a..e6d681b40 100644
--- a/src/backend/access/index/Makefile
+++ b/src/backend/access/index/Makefile
@@ -16,6 +16,7 @@ OBJS = \
 	amapi.o \
 	amvalidate.o \
 	genam.o \
-	indexam.o
+	indexam.o \
+	indexbatch.o
 
 include $(top_srcdir)/src/backend/common.mk
diff --git a/src/backend/access/index/amapi.c b/src/backend/access/index/amapi.c
index efa007030..d4adbbeb2 100644
--- a/src/backend/access/index/amapi.c
+++ b/src/backend/access/index/amapi.c
@@ -55,6 +55,11 @@ GetIndexAmRoutine(Oid amhandler)
 	Assert(routine->amrescan != NULL);
 	Assert(routine->amendscan != NULL);
 
+	/* Assert that AM doesn't have an invalid combination of callbacks */
+	Assert((routine->amgetbatch != NULL) == (routine->amunguardbatch != NULL));
+	Assert(routine->amkillitemsbatch == NULL || routine->amgetbatch != NULL);
+	Assert(routine->amgetbatch != NULL || routine->amposreset == NULL);
+
 	return routine;
 }
 
diff --git a/src/backend/access/index/genam.c b/src/backend/access/index/genam.c
index 1512438d6..54042f6f5 100644
--- a/src/backend/access/index/genam.c
+++ b/src/backend/access/index/genam.c
@@ -89,6 +89,8 @@ RelationGetIndexScan(Relation indexRelation, int nkeys, int norderbys)
 	scan->xs_snapshot = InvalidSnapshot;	/* caller must initialize this */
 	scan->numberOfKeys = nkeys;
 	scan->numberOfOrderBys = norderbys;
+	scan->usebatchring = false; /* set later for amgetbatch callers */
+	memset(&scan->batchcache, 0, sizeof(scan->batchcache));
 
 	/*
 	 * We allocate key workspace here, but it won't get filled until amrescan.
@@ -128,6 +130,11 @@ RelationGetIndexScan(Relation indexRelation, int nkeys, int norderbys)
 
 	scan->xs_getnext_slot = NULL;
 
+	scan->batch_index_opaque_static = 0;
+	scan->batch_tuples_workspace = 0;
+	scan->batch_table_opaque_size = 0;
+	scan->batch_base_offset = 0;
+
 	scan->xs_name_cstring_attnums = NULL;
 	scan->xs_name_cstring_count = 0;
 
